unit RandomFormU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TRandomForm = class(TForm)
    Label1: TLabel;
    Panel1: TPanel;
    BitsLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);

  private
    FBits       : Integer;
    FTemp       : string;
    FPrevX      : Integer;
    FPrevY      : Integer;

  protected
    function    GetBitCount: Integer; virtual;
    function    GetSeed: string; virtual;

  public
    procedure   Init;

    property    Bits: Integer read FBits write FBits;
    property    BitCount: Integer read GetBitCount;
    property    Seed: string read GetSeed;
  end;

var
  RandomForm: TRandomForm;

implementation

{$R *.DFM}

uses
  MD5;

resourcestring
  BitsH         = 'Bits harvested: ';

const
  DEF_BITS      = 128;

  function      TRandomForm.GetBitCount;
  begin
    Result := Length (FTemp)
  end;

  function      TRandomForm.GetSeed;
  var
    i, m        : Integer;
    s           : string;

  begin
    Result := '';

    while FTemp <> '' do
      begin
        s := Copy (FTemp, 1, 8);

        m := 0;
        for i := 1 to Length (s) do
          m := (m shl 1) or (Ord (s [i]) - Ord ('0'));

        Result := Result + Chr (m);
        Delete (FTemp, 1, 8);
      end;

    // no longer needed
    // Result := StrMD5 (Result);
  end;

  procedure     TRandomForm.Init;
  begin
    FTemp := '';
    FPrevX := 0;
    FPrevY := 0;

    BitsLabel.Caption := BitsH + '0';
  end;

procedure TRandomForm.FormCreate(Sender: TObject);
begin
  Bits := DEF_BITS;

  Canvas.Pen.Color := clRed;
end;

procedure TRandomForm.Panel1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if (Abs (FPrevX - X) < 5) or (Abs (FPrevY - Y) < 5) then
    Exit;

  if (FPrevX <= X) xor (FPrevY <= Y) then
    FTemp := FTemp + '1'
  else
    FTemp := FTemp + '0';

//  Canvas.MoveTo (FPrevX, FPrevY);
//  Canvas.LineTo (X, Y);

  FPrevX := X;
  FPrevY := Y;

  BitsLabel.Caption := BitsH + IntToStr (BitCount);

  if BitCount > Bits then
    ModalResult := mrOk;
end;

end.
